pub type MPResult<T> = Result<T, wasmi::core::Trap>;

pub trait MinimalPreview1 {
    fn args_get(&mut self, memory: &mut [u8], argv: i32, argv_buf: i32) -> MPResult<i32>;
    fn args_sizes_get(&mut self, memory: &mut [u8], offset0: i32, offset1: i32) -> MPResult<i32>;
    fn environ_get(&mut self, memory: &mut [u8], environ: i32, environ_buf: i32) -> MPResult<i32>;
    fn environ_sizes_get(&mut self, memory: &mut [u8], offset0: i32, offset1: i32) -> MPResult<i32>;
    fn clock_res_get(&mut self, memory: &mut [u8], id: i32, offset0: i32) -> MPResult<i32>;
    fn clock_time_get(&mut self, memory: &mut [u8], id: i32, precision: i64, offset0: i32) -> MPResult<i32>;
    fn fd_advise(&mut self, memory: &mut [u8], fd: i32, offset: i64, len: i64, advice: i32) -> MPResult<i32>;
    fn fd_allocate(&mut self, memory: &mut [u8], fd: i32, offset: i64, len: i64) -> MPResult<i32>;
    fn fd_close(&mut self, memory: &mut [u8], fd: i32) -> MPResult<i32>;
    fn fd_datasync(&mut self, memory: &mut [u8], fd: i32) -> MPResult<i32>;
    fn fd_fdstat_get(&mut self, memory: &mut [u8], fd: i32, offset0: i32) -> MPResult<i32>;
    fn fd_fdstat_set_flags(&mut self, memory: &mut [u8], fd: i32, flags: i32) -> MPResult<i32>;
    fn fd_fdstat_set_rights(&mut self, memory: &mut [u8], fd: i32, fs_rights_base: i64, fs_rights_inheriting: i64) -> MPResult<i32>;
    fn fd_filestat_get(&mut self, memory: &mut [u8], fd: i32, offset0: i32) -> MPResult<i32>;
    fn fd_filestat_set_size(&mut self, memory: &mut [u8], fd: i32, size: i64) -> MPResult<i32>;
    fn fd_filestat_set_times(&mut self, memory: &mut [u8], fd: i32, atim: i64, mtim: i64, fst_flags: i32) -> MPResult<i32>;
    fn fd_pread(&mut self, memory: &mut [u8], fd: i32, iov_buf: i32, iov_buf_len: i32, offset: i64, offset0: i32) -> MPResult<i32>;
    fn fd_prestat_get(&mut self, memory: &mut [u8], fd: i32, offset0: i32) -> MPResult<i32>;
    fn fd_prestat_dir_name(&mut self, memory: &mut [u8], fd: i32, path: i32, path_len: i32) -> MPResult<i32>;
    fn fd_pwrite(&mut self, memory: &mut [u8], fd: i32, ciov_buf: i32, ciov_buf_len: i32, offset: i64, offset0: i32) -> MPResult<i32>;
    fn fd_read(&mut self, memory: &mut [u8], fd: i32, iov_buf: i32, iov_buf_len: i32, offset1: i32) -> MPResult<i32>;
    fn fd_readdir(&mut self, memory: &mut [u8], fd: i32, buf: i32, buf_len: i32, cookie: i64, offset0: i32) -> MPResult<i32>;
    fn fd_renumber(&mut self, memory: &mut [u8], fd: i32, to: i32) -> MPResult<i32>;
    fn fd_seek(&mut self, memory: &mut [u8], fd: i32, offset: i64, whence: i32, offset0: i32) -> MPResult<i32>;
    fn fd_sync(&mut self, memory: &mut [u8], fd: i32) -> MPResult<i32>;
    fn fd_tell(&mut self, memory: &mut [u8], fd: i32, offset0: i32) -> MPResult<i32>;
    fn fd_write(&mut self, memory: &mut [u8], fd: i32, ciov_buf: i32, ciov_buf_len: i32, offset0: i32) -> MPResult<i32>;
    fn path_create_directory(&mut self, memory: &mut [u8], fd: i32, offset: i32, length: i32) -> MPResult<i32>;
    fn path_filestat_get(&mut self, memory: &mut [u8], fd: i32, flags: i32, offset: i32, length: i32, offset0: i32) -> MPResult<i32>;
    fn path_filestat_set_times(
        &mut self,
        memory: &mut [u8],
        fd: i32,
        flags: i32,
        offset: i32,
        length: i32,
        atim: i64,
        mtim: i64,
        fst_flags: i32,
    ) -> MPResult<i32>;
    fn path_link(
        &mut self,
        memory: &mut [u8],
        old_fd: i32,
        old_flags: i32,
        old_offset: i32,
        old_length: i32,
        new_fd: i32,
        new_offset: i32,
        new_length: i32,
    ) -> MPResult<i32>;
    fn path_open(
        &mut self,
        memory: &mut [u8],
        fd: i32,
        dirflags: i32,
        offset: i32,
        length: i32,
        oflags: i32,
        fs_rights_base: i64,
        fdflags: i64,
        fs_rights_inheriting: i32,
        offset0: i32,
    ) -> MPResult<i32>;
    fn path_readlink(
        &mut self,
        memory: &mut [u8],
        fd: i32,
        offset: i32,
        length: i32,
        buf: i32,
        buf_len: i32,
        offset0: i32,
    ) -> MPResult<i32>;
    fn path_remove_directory(
        &mut self,
        memory: &mut [u8],
        fd: i32, offset: i32, length: i32
    ) -> MPResult<i32>;
    fn path_rename(
        &mut self,
        memory: &mut [u8],
        fd: i32,
        old_offset: i32,
        old_length: i32,
        new_fd: i32,
        new_offset: i32,
        new_length: i32,
    ) -> MPResult<i32>;
    fn path_symlink(
        &mut self,
        memory: &mut [u8],
        old_offset: i32,
        old_length: i32,
        fd: i32,
        new_offset: i32,
        new_length: i32,
    ) -> MPResult<i32>;
    fn path_unlink_file(&mut self, memory: &mut [u8], fd: i32, offset: i32, length: i32) -> MPResult<i32>;
    fn poll_oneoff(&mut self, memory: &mut [u8], in_: i32, out: i32, nsubscriptions: i32, offset0: i32) -> MPResult<i32>;
    fn proc_exit(&mut self, memory: &mut [u8], rval: i32) -> MPResult<()>;
    fn proc_raise(&mut self, memory: &mut [u8], sig: i32) -> MPResult<i32>;
    fn sched_yield(&mut self, memory: &mut [u8]) -> MPResult<i32>;
    fn random_get(&mut self, memory: &mut [u8], buf: i32, buf_len: i32) -> MPResult<i32>;
    fn sock_accept(&mut self, memory: &mut [u8], fd: i32, flags: i32, offset0: i32) -> MPResult<i32>;
    fn sock_recv(
        &mut self,
        memory: &mut [u8],
        fd: i32,
        iov_buf: i32,
        iov_buf_len: i32,
        ri_flags: i32,
        offset0: i32,
        offset1: i32,
    ) -> MPResult<i32>;
    fn sock_send(
        &mut self,
        memory: &mut [u8],
        fd: i32, ciov_buf: i32, ciov_buf_len: i32, si_flags: i32, offset0: i32) -> MPResult<i32>;
    fn sock_shutdown(
        &mut self,
        memory: &mut [u8],
        fd: i32, how: i32) -> MPResult<i32>;
}